﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Management.Automation;
using System.Text.RegularExpressions;

namespace MyBinaryModule
{
    
    //Get Even or Odd
    [Cmdlet(VerbsCommon.Get,"EvenOrOdd")]
    public class EvenorOdd : Cmdlet
    {
        [Parameter(Position = 0,
           ValueFromPipeline = true,
           ValueFromPipelineByPropertyName = true,
           HelpMessage = @"The range of numbers to be checked")]
        public int[] Numbers
        {
            get { return num; }
            set { num = value; }
        }
        private int[] num;

        protected override void ProcessRecord()
        {
            base.ProcessRecord();

            foreach (int i in Numbers)
            {
                if ((i % 2) != 0)
                    WriteObject(i.ToString() + " is odd");
                else
                    WriteObject(i.ToString() + " is even");
            }

        }
    }
    
    //Validate Email Address using Regex
    [Cmdlet("Validate", "EmailAddress")]
    public class ValidateEmailAddress : Cmdlet
    {
        [Parameter(Position = 0,
           ValueFromPipeline = true,
           ValueFromPipelineByPropertyName = true,
           HelpMessage = @"The E-mail address to validate")]
        public string EmailAddress
        {
            get { return Email; }
            set { Email = value; }
        }
        private string Email;

        protected override void ProcessRecord()
        {
            base.ProcessRecord();

            //Write Verbose information to be displayed by -Verbose
            WriteVerbose("Validating Email Address: " + EmailAddress);

            //Write Verbose information to be displayed by -Debug
            WriteDebug("Validating Email Address: " + EmailAddress);

            Regex reg = new Regex(@"(\w+@[a-zA-Z_-]+?\.[a-zA-Z_-]{2,6})");
            
            //Write Object information to be displayed as a result of cmdlet execution
            WriteObject(reg.IsMatch(EmailAddress));  
        }
    }


}
